
acm_init:

;acm.mbas,12 :: 		sub procedure init()
;acm.mbas,13 :: 		option_reg=   %10000111
	MOVLW      135
	MOVWF      OPTION_REG+0
;acm.mbas,14 :: 		intcon=       %11000000
	MOVLW      192
	MOVWF      INTCON+0
;acm.mbas,15 :: 		pie1.RCIE=    1
	BSF        PIE1+0, 5
;acm.mbas,16 :: 		uart1_init(9600)
	MOVLW      51
	MOVWF      SPBRG+0
	BSF        TXSTA+0, 2
	CALL       _UART1_Init+0
;acm.mbas,17 :: 		ansel=0
	CLRF       ANSEL+0
;acm.mbas,18 :: 		anselh=0
	CLRF       ANSELH+0
;acm.mbas,19 :: 		trisa=%000111
	MOVLW      7
	MOVWF      TRISA+0
;acm.mbas,20 :: 		trisc=0
	CLRF       TRISC+0
;acm.mbas,21 :: 		portc=0
	CLRF       PORTC+0
	RETURN
; end of acm_init

acm_interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;acm.mbas,23 :: 		sub procedure interrupt
;acm.mbas,24 :: 		rec=rcreg
	MOVF       RCREG+0, 0
	MOVWF      _rec+0
;acm.mbas,25 :: 		input_buffer=input_buffer + rec
	MOVLW      FLOC_acm_interrupt+0
	MOVWF      FSR
	MOVLW      _input_buffer+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	MOVF       _rec+0, 0
	MOVWF      INDF+0
	INCF       FSR, 1
	CLRF       INDF+0
	MOVLW      _input_buffer+0
	MOVWF      FSR
	MOVLW      FLOC_acm_interrupt+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	CLRF       INDF+0
L_acm_interrupt27:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of acm_interrupt

acm_phase_1:

;acm.mbas,27 :: 		sub procedure phase_1()
;acm.mbas,28 :: 		L1=1
	BSF        PORTC+0, 1
;acm.mbas,29 :: 		L2=0
	BCF        PORTC+0, 3
;acm.mbas,30 :: 		L3=0
	BCF        PORTC+0, 5
;acm.mbas,31 :: 		H1=0
	BCF        PORTC+0, 0
;acm.mbas,32 :: 		H2=1
	BSF        PORTC+0, 2
;acm.mbas,33 :: 		H3=1
	BSF        PORTC+0, 4
	RETURN
; end of acm_phase_1

acm_phase_2:

;acm.mbas,35 :: 		sub procedure phase_2()
;acm.mbas,36 :: 		L1=0
	BCF        PORTC+0, 1
;acm.mbas,37 :: 		L2=1
	BSF        PORTC+0, 3
;acm.mbas,38 :: 		L3=0
	BCF        PORTC+0, 5
;acm.mbas,39 :: 		H1=1
	BSF        PORTC+0, 0
;acm.mbas,40 :: 		H2=0
	BCF        PORTC+0, 2
;acm.mbas,41 :: 		H3=1
	BSF        PORTC+0, 4
	RETURN
; end of acm_phase_2

acm_phase_3:

;acm.mbas,43 :: 		sub procedure phase_3()
;acm.mbas,44 :: 		L1=0
	BCF        PORTC+0, 1
;acm.mbas,45 :: 		L2=0
	BCF        PORTC+0, 3
;acm.mbas,46 :: 		L3=1
	BSF        PORTC+0, 5
;acm.mbas,47 :: 		H1=1
	BSF        PORTC+0, 0
;acm.mbas,48 :: 		H2=1
	BSF        PORTC+0, 2
;acm.mbas,49 :: 		H3=0
	BCF        PORTC+0, 4
	RETURN
; end of acm_phase_3

acm_stop_p:

;acm.mbas,51 :: 		sub procedure stop_p()
;acm.mbas,52 :: 		L1=0
	BCF        PORTC+0, 1
;acm.mbas,53 :: 		L2=0
	BCF        PORTC+0, 3
;acm.mbas,54 :: 		L3=0
	BCF        PORTC+0, 5
;acm.mbas,55 :: 		H1=0
	BCF        PORTC+0, 0
;acm.mbas,56 :: 		H2=0
	BCF        PORTC+0, 2
;acm.mbas,57 :: 		H3=0
	BCF        PORTC+0, 4
	RETURN
; end of acm_stop_p

acm_CS_wait:

;acm.mbas,59 :: 		sub procedure CS_wait()
;acm.mbas,60 :: 		tmr0=0
	CLRF       TMR0+0
;acm.mbas,61 :: 		while CS=0
L_acm_CS_wait8:
	BTFSC      PORTA+0, 0
	GOTO       L_acm_CS_wait9
;acm.mbas,62 :: 		if tmr0>200 then
	MOVF       TMR0+0, 0
	SUBLW      200
	BTFSC      STATUS+0, 0
	GOTO       L_acm_CS_wait13
;acm.mbas,63 :: 		goto endcs
	GOTO       L_acm_CS_wait_endcs
L_acm_CS_wait13:
;acm.mbas,65 :: 		wend
	GOTO       L_acm_CS_wait8
L_acm_CS_wait9:
;acm.mbas,66 :: 		endcs:
L_acm_CS_wait_endcs:
;acm.mbas,67 :: 		stop_p
	CALL       acm_stop_p+0
;acm.mbas,68 :: 		while tmr0<200
L_acm_CS_wait17:
	MOVLW      200
	SUBWF      TMR0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_acm_CS_wait18
;acm.mbas,69 :: 		wend
	GOTO       L_acm_CS_wait17
L_acm_CS_wait18:
	RETURN
; end of acm_CS_wait

_main:

;acm.mbas,71 :: 		main:
;acm.mbas,72 :: 		init
	CALL       acm_init+0
;acm.mbas,73 :: 		delay_ms(300)
	MOVLW      4
	MOVWF      R11+0
	MOVLW      12
	MOVWF      R12+0
	MOVLW      51
	MOVWF      R13+0
L__main22:
	DECFSZ     R13+0, 1
	GOTO       L__main22
	DECFSZ     R12+0, 1
	GOTO       L__main22
	DECFSZ     R11+0, 1
	GOTO       L__main22
	NOP
	NOP
;acm.mbas,74 :: 		loop:
L__main_loop:
;acm.mbas,75 :: 		if length(input_buffer)>5 then
	MOVLW      _input_buffer+0
	MOVWF      FARG_Length_Text+0
	CALL       _Length+0
	MOVF       R0+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main28
	MOVF       R0+0, 0
	SUBLW      5
L__main28:
	BTFSC      STATUS+0, 0
	GOTO       L__main25
;acm.mbas,76 :: 		uart1_write_text(input_buffer)
	MOVLW      _input_buffer+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	CALL       _UART1_Write_Text+0
;acm.mbas,77 :: 		input_buffer=""
	CLRF       _input_buffer+0
L__main25:
;acm.mbas,79 :: 		phase_1
	CALL       acm_phase_1+0
;acm.mbas,80 :: 		CS_wait
	CALL       acm_CS_wait+0
;acm.mbas,81 :: 		phase_2
	CALL       acm_phase_2+0
;acm.mbas,82 :: 		CS_wait
	CALL       acm_CS_wait+0
;acm.mbas,83 :: 		phase_3
	CALL       acm_phase_3+0
;acm.mbas,84 :: 		CS_wait
	CALL       acm_CS_wait+0
;acm.mbas,85 :: 		goto loop
	GOTO       L__main_loop
	GOTO       $+0
; end of _main
